function [dayweight,periodweight]=tabellStopDate(w,mndtemp,startDate,stopDate,model, harvestweight)
%model=0-->autumn smolt, model=1-->spring smolt
i=1;
tabell=zeros(700,1);
tabell(1)=w;

startDate=datenum(startDate);
d=startDate;
stopDate=datenum(stopDate);
if model==1
    while d<=stopDate
        t=temptoday(d,mndtemp);
        tabell(i+1)=tabell(i)*(1+(vaarfisk(tabell(i),t,d)/100));
        d=d+1;
        i=i+1;
    end
else
    while d<=stopDate
        t=temptoday(d,mndtemp);
        tabell(i+1)=tabell(i)*(1+(hostfisk(tabell(i),t,d)/100));
        d=d+1;
        i=i+1;
    end
end
dayweight=tabell;
j=1;

n=ceil((stopDate-startDate)/14)+1;
tabell2=zeros(n,1);

for j=1:n
    tabell2(j)=tabell(1+14*(j-1));
    
end

removerest=false;
for i=1:length(tabell2)
    if removerest
        tabell2(i)=0;
    elseif tabell2(i)>harvestweight
        removerest=true;
    end
end
periodweight=tabell2;

function out=dagligtilvekst(w,t)

w=log(w);
foo = (4.99409 - 3.45381 * w - 0.061185 * t + 1.15949 * w * w + 0.00920083 * t * t + 0.062954 * w * t - 0.18969 * w * w * w + -0.0000520438 * t * t * t - 0.00514174 * w * w * t - 0.00475576 * w * t * t + 0.015135 * w * w * w * w + 0.0000101096 * t * t * t * t + -0.000799909 * w * w * w * t - 0.0000729093 * w * t * t * t + 0.000869143 * w * w * t * t - 0.000471381 * w * w * w * w * w - 0.000000518995 * t * t * t * t * t + 0.0000748838 * w * w * w * w * t +0.00000233776 * w * t * t * t * t + -0.0000417922 * w * w * w * t * t);
out=(foo^2-1);

function out=hostfisk(w,t,d)
out=dagligtilvekst(w,t)*0.93*LT_adj_S0(w,t,d);

function out=vaarfisk(w,t,d)
out=dagligtilvekst(w,t)*0.98*LT_adj_S1(w,t,d);

function out=LT_adj_S0(w, t, d)
tmp=datevec(d);
monthnum = tmp(2);

smallfishadjust=zeros(1,12);
smallfishadjust(1) = 1;
smallfishadjust(2) = 1;
smallfishadjust(3) = 1;
smallfishadjust(4) = 1;
smallfishadjust(5) = 1; 
smallfishadjust(6) = 1;
smallfishadjust(7) = 1;
smallfishadjust(8) = 1;
smallfishadjust(9) = 1;
smallfishadjust(10) = 1;
smallfishadjust(11) = 1;
smallfishadjust(12) = 1;

mediumfishadjust=zeros(1,12);
mediumfishadjust(1) = 0.85;
mediumfishadjust(2) = 0.85;
mediumfishadjust(3) = 0.8;
mediumfishadjust(4) = 0.85;
mediumfishadjust(5) = 0.9;
mediumfishadjust(6) = 1;
mediumfishadjust(7) = 1.25;
mediumfishadjust(8) = 1.4;
mediumfishadjust(9) = 1.25;
mediumfishadjust(10) = 1.25;
mediumfishadjust(11) = 1.2;
mediumfishadjust(12) = 1;

bigfishadjust=zeros(1,12);
bigfishadjust(1) = 1;
bigfishadjust(2) = 1;
bigfishadjust(3) = 1;
bigfishadjust(4) = 1;
bigfishadjust(5) = 1;
bigfishadjust(6) = 1;
bigfishadjust(7) = 1;
bigfishadjust(8) = 1;
bigfishadjust(9) = 1;
bigfishadjust(10) = 1;
bigfishadjust(11) = 1;
bigfishadjust(12) = 1;


if monthnum <= 6 
    if w > 3000
        out = bigfishadjust(monthnum);
        else
        out = mediumfishadjust(monthnum);
    end
    
else
    if w < 700 
        out = smallfishadjust(monthnum);
    else
        out = mediumfishadjust(monthnum);
    end 
end 

function out=LT_adj_S1(w, t, d)
tmp=datevec(d);
monthnum = tmp(2);
    
smallfishadjust=zeros(1,12);
smallfishadjust(1) = 0.8;
smallfishadjust(2) = 0.8;
smallfishadjust(3) = 0.8;
smallfishadjust(4) = 0.85;
smallfishadjust(5) = 0.9;
smallfishadjust(6) = 1;
smallfishadjust(7) = 1;
smallfishadjust(8) = 1;
smallfishadjust(9) = 1;
smallfishadjust(10) = 1;
smallfishadjust(11) = 1;
smallfishadjust(12) = 0.7;

mediumfishadjust=zeros(1,12);
mediumfishadjust(1) = 0.7;
mediumfishadjust(2) = 0.7;
mediumfishadjust(3) = 0.9;
mediumfishadjust(4) = 1.1;
mediumfishadjust(5) = 1.3;
mediumfishadjust(6) = 1.3;
mediumfishadjust(7) = 1.3;
mediumfishadjust(8) = 1.3;
mediumfishadjust(9) = 1.1;
mediumfishadjust(10) = 1;
mediumfishadjust(11) = 0.9;
mediumfishadjust(12) = 0.8;

bigfishadjust=zeros(1,12);
bigfishadjust(1) = 0.8;
bigfishadjust(2) = 0.8;
bigfishadjust(3) = 0.8;
bigfishadjust(4) = 0.8;
bigfishadjust(5) = 0.9;
bigfishadjust(6) = 0.9;
bigfishadjust(7) = 1;
bigfishadjust(8) = 1;
bigfishadjust(9) = 1;
bigfishadjust(10) = 1;
bigfishadjust(11) = 1;
bigfishadjust(12) = 1;



if monthnum <= 6 
    if w < 800
        out =  smallfishadjust(monthnum);
        else
        out = mediumfishadjust(monthnum);
    end
    
else
    if w < 1800 
        out = smallfishadjust(monthnum);
    else
        out = mediumfishadjust(monthnum);
    end 
end 

function out=temptoday(d,mndtemps)

vec=datevec(d);
year=vec(1);
month=vec(2);
day=vec(3);
dayno=datenum(d)-datenum(strcat('31-Dec-',num2str(year-1)));

daysinmonth=eomday(year,month);
xin(1) = -46; % 'nov
xin(2) = -16;%  'dec
xin(3) = 15;  % 'jan
xin(4) = 46;   %'feb
xin(5) = 74;   %'mar
xin(6) = 105;  %'apr
xin(7) = 135;  %'may
xin(8) = 166;  %'jun
xin(9) = 196;  %'jul
xin(10) = 227;  %'aug
xin(11) = 258; %'sep
xin(12) = 288; %'oct
xin(13) = 319; %'nov
xin(14) = 349; %'dec
xin(15) = 380; %'jan
xin(16) = 408; %'feb

yin(1) = mndtemps(11); % 'nov
yin(2) = mndtemps(12) ; %'dec
yin(3) = mndtemps(1);   %'jan
yin(4) = mndtemps(2);   %'feb
yin(5) = mndtemps(3);   %'mar
yin(6) = mndtemps(4);   %'apr
yin(7) = mndtemps(5);   %'may
yin(8) = mndtemps(6);   %'jun
yin(9) = mndtemps(7);   %'jul
yin(10) = mndtemps(8);   %'aug
yin(11) = mndtemps(9);  %'sep
yin(12) = mndtemps(10); %'oct
yin(13) = mndtemps(11); %'nov
yin(14) = mndtemps(12); %'dec
yin(15) = mndtemps(1);  %'jan
yin(16) = mndtemps(2);  %'feb


N=1;
set=false;
while  N<16 && set==false
    if dayno < xin(N) 
        h2 = N;
        h1 = N - 1;
        set=true;
    end
    N=N+1;
end


out = yin(h1) + (dayno - xin(h1)) / (xin(h2) - xin(h1)) * (yin(h2) - yin(h1));
