%[x y]=tabellStopDate(100,temps,'9-Feb-2012','31-May-2012')
t=cputime;
fprintf('Running model: Spring smolt 9-Feb-2012\n');
startdate='9-Feb-2012';
model=1;%spring smolt
stopdate='31-May-2012';
startdate=datenum(startdate);
stopdate=datenum(stopdate);
smoltweights=[70 100 150];
numberofsmoltweights=length(smoltweights);
load('scenariotemps');%The temperature scenarios are stored in a separate file called scenariotemps.mat. The variable name is scenariotemps.
load('weightclass');
numberofweightclasses=length(weightclass);
[x y]=size(scenariotemps);
numberofscenarios=x;
numberofperiods=floor((stopdate-startdate)/14)+1;
filename='smolt-9-feb.dat';
%The file is created here, if it exists from before, it is emptied
fid=fopen(filename,'w');
fclose(fid);

for i=1:numberofsmoltweights
    for j=1:numberofscenarios
        outtable=zeros(numberofperiods,numberofperiods);
        coefficients=zeros(numberofweightclasses,numberofperiods);
        tablename=strcat('smolt-9-feb-',num2str(smoltweights(i)),'g-Scenario',num2str(j));
        fprintf(strcat(tablename,'\n'));
        for k=1:numberofperiods
            sdate=startdate+14*(k-1);
            [x y]=tabellStopDate(smoltweights(i),scenariotemps(j,:),sdate,stopdate,model);
            outtable(k:numberofperiods,k)=y;
            coefficients(:,k)=findweightclasscoefficients(outtable(numberofperiods,k),weightclass);
        end
        appendtofile(filename,tablename,outtable);
        appendtofile(filename,strcat(tablename,'Coeff'),coefficients);

    end
end

fprintf('Model complete - Computation time:\n');
fprintf(strcat(num2str(cputime-t)),' seconds\n');