%[x y]=tabellStopDate(100,temps,'9-Feb-2012','31-May-2012')
t=cputime;
fprintf('Running model: autumn smolt 16-May-2011\n');
startdate='11-Jul-2011';
model=0;%autumn smolt
stopdate='28-Nov-2011';
startdate=datenum(startdate);
stopdate=datenum(stopdate);
load('smoltweights');
numberofsmoltweights=length(smoltweights);
load('scenariotemps');%The temperature scenarios are stored in a separate file called scenariotemps.mat. The variable name is scenariotemps.
load('weightclass');
numberofweightclasses=length(weightclass);
[x y]=size(scenariotemps);
numberofscenarios=x;
numberofperiods=floor((stopdate-startdate)/14)+1;
filename='SMOLTS0_FIRSTSTAGE.dat';
%The file is created here, if it exists from before, it is emptied
fid=fopen(filename,'w');
fclose(fid);




BAll=[];
CoeffAll=[];
tablename=strcat('SMOLTS0_FIRSTSTAGE');
for i=1:numberofsmoltweights
    B=[];
    Coeff=[];
    for j=1:numberofscenarios
        outtable=zeros(numberofperiods,numberofperiods);
        coefficients=zeros(numberofweightclasses,numberofperiods);

        fprintf(strcat(tablename,'\n'));
        for k=1:numberofperiods
            sdate=startdate+14*(k-1);
            [x y]=tabellStopDate(smoltweights(i),scenariotemps(j,:),sdate,stopdate,model,6000);
            outtable(k:numberofperiods,k)=y;
            coefficients(:,k)=findweightclasscoefficients(outtable(numberofperiods,k),weightclass);
        end
        B=[B;outtable];
        Coeff=[Coeff;coefficients];

    end
    BAll=[BAll;B];
    CoeffAll=[CoeffAll;Coeff];
end
appendtofile(filename,tablename,BAll);

%shortmatrix(coefficients,filename,strcat(tablename,'Coeff'));
appendtofile(filename,strcat(tablename,'COEFF'),CoeffAll);


fprintf('Model complete - Computation time:\n');
fprintf(strcat(num2str(cputime-t)),' seconds\n');